package sun.net.httpserver;

import java.io.IOException;
import java.io.InputStream;

class FixedLengthInputStream extends LeftOverInputStream
{
    private long remaining;
    
    FixedLengthInputStream(ExchangeImpl exchangeImpl, InputStream inputStream, long remaining) {
        super(exchangeImpl, inputStream);
        this.remaining = remaining;
    }
    
    @Override
    protected int readImpl(byte[] b, int off, int len) throws IOException {
        this.eof = (this.remaining == 0L);
        if (this.eof) {
            return -1;
        }
        if ((long)len > this.remaining) {
            len = (int)this.remaining;
        }
        int read = this.in.read(b, off, len);
        if (read > -1) {
            this.remaining -= (long)read;
            if (this.remaining == 0L) {
                this.t.getServerImpl().requestCompleted(this.t.getConnection());
            }
        }
        return read;
    }
    
    @Override
    public int available() throws IOException {
        if (this.eof) {
            return 0;
        }
        int available = this.in.available();
        return ((long)available < this.remaining) ? available : ((int)this.remaining);
    }
    
    @Override
    public boolean markSupported() {
        return false;
    }
    
    @Override
    public void mark(int n) {
    }
    
    @Override
    public void reset() throws IOException {
        throw new IOException("mark/reset not supported");
    }
}
